<template>
    <div class="container">

        <div class="row">
            <div class="col-md-12">
                <button type="button" class="btn btn-primary" v-on:click="addForm = !addForm">Add Product</button>
            </div>

        </div>
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">Product List</div>

                    <div class="card-body">
                        <table class="table table-hover">
                            <thead>
                                <tr>
                                    <th>Product Name</th>
                                    <th></th>
                                    <th>Detail</th>
                                    <th>Shop</th>
                                    <th>Status</th>
                                    <!-- <th></th> -->
                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="product in products" :key="product.id">
                                    <td>{{ product.name }}</td>
                                    <td><img :src="'/uploads/' + product.image"
                                            v-if="product.image != '' && product.image != null" style="max-width:200px;">
                                    </td>
                                    <td class="d-flex flex-column">
                                        <span>Price : {{ product.price }}</span>
                                        <span>Discount : {{ product.discount }}</span>
                                        <span>Vat Price : {{ product.vatprice }}</span>
                                        <span>Total Price : {{ product.totalprice }}</span>
                                        <br>
                                        <span>Create Date : {{ product.created_date }}</span>
                                        <span>Update Date : {{ product.updated_date }}</span>
                                    </td>
                                    <td>{{ product.shop_name }}</td>
                                    <td>{{ product.status == 1 ? 'Active' : 'In Active' }}</td>
                                    <!-- <td>
                                        <i class="fa-solid fa-pen-to-square"></i>
                                        <i class="fa-solid fa-trash-can"></i>
                                    </td> -->
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

        <div class="add-container" v-show="addForm">
            <div class="addForm">
                <div>
                    <div class="form-group row">
                        <label for="name" class="col-md-4 col-form-label">Name</label>
                        <div class="col-md-8">
                            <input type="text" id="name" class="form-control" name="name" v-model="adddata.name" required
                                autofocus>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="price" class="col-md-4 col-form-label">Price</label>
                        <div class="col-md-8">
                            <input type="text" id="price" class="form-control" name="price" v-model="adddata.price" required
                                autofocus>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="discount" class="col-md-4 col-form-label">Discount</label>
                        <div class="col-md-8">
                            <input type="text" id="discount" class="form-control" name="discount" v-model="adddata.discount"
                                 required
                                autofocus>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="afterdiscount" class="col-md-4 col-form-label">After Discount</label>
                        <div class="col-md-8">
                            <input type="text" id="afterdiscount" class="form-control" name="afterdiscount" v-model="adddata.afterdiscount" readonly>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="vat" class="col-md-4 col-form-label">Vat 7%</label>
                        <div class="col-md-8">
                            <input type="text" id="vat" class="form-control" name="vat" v-model="adddata.vat" readonly>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="totalprice" class="col-md-4 col-form-label">Total Price</label>
                        <div class="col-md-8">
                            <input type="text" id="totalprice" readonly class="form-control" name="totalprice" v-model="adddata.totalprice">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="image" class="col-md-4 col-form-label">Image</label>
                        <div class="col-md-8">
                            <input type="file" id="image" class="form-control" name="image"
                                v-on:change="onFileChange($event)">
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="shop_id" class="col-md-4 col-form-label">Shop</label>
                        <div class="col-md-6">
                            <select v-model="adddata.shop_id" class="form-control" id="shop_id" name="shop_id">
                                <option v-for="shop in shops" :key="shop.id" :value="shop.id">{{ shop.name }}</option>
                            </select>
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="status" class="col-md-4 col-form-label">Status</label>
                        <div class="col-md-6">
                            <select v-model="adddata.status" class="form-control" id="status" name="status">
                                <option value="1">Active</option>
                                <option value="0">In Active</option>
                            </select>
                        </div>
                    </div>

                    <div class="col-md-6 offset-md-4 d-flex justify-content-between">
                        <button class="btn btn-light" v-on:click="addForm = !addForm">
                            Cancel
                        </button>
                        <button class="btn btn-primary" v-on:click="addProduct(adddata)">
                            Save
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
export default {
    data() {
        return {
            products: {},
            addForm: false,
            adddata: {
                name: null,
                price: null,
                discount: null,
                vat: null,
                totalprice: null,
                status: 1,
                shop_id: 1,
                image: null
            },
            shops: {}
        }
    },
    methods: {
        getProduct() {
            axios.get('/api/products')
                .then((res) => {
                    console.log(res.data.data)
                    this.products = res.data.data;
                }).catch((err) => {
                    console.log('error');
                    console.log(err)
                })
        },
        getShop() {
            axios.get('/api/getShop')
                .then((res) => {
                    console.log(res.data.data)
                    this.shops = res.data.data;
                }).catch((err) => {
                    console.log('error');
                    console.log(err)
                })
        },
        addProduct(data) {
            // console.log(data);
            const formData = new FormData();
            formData.append('name', data.name);
            formData.append('status', data.status);
            formData.append('shop_id', data.shop_id);
            if(data.image!=null && data.image!=''){formData.append('image', data.image);}
            
            formData.append('price', data.price);
            formData.append('discount', data.discount);
            // console.log(formData)
            const headers = { 'Content-Type': 'multipart/form-data' };
            axios.post('/api/products', formData, { headers })
                .then((res) => {
                    console.log(res)
                    this.getProduct();
                    this.addForm = !this.addForm
                    this.adddata= {
                name: null,
                price: null,
                discount: null,
                vat: null,
                totalprice: null,
                status: 1,
                shop_id: 1,
                image: null
            }
                }).catch((err) => {
                    console.log('error');
                    console.log(err)
                })
        },
        onFileChange(e) {
            var files = e.target.files || e.dataTransfer.files;

            if (!files.length)
                return;
            this.adddata.image = files[0]
        },
    },
    watch: {
        'adddata.price'(){
            this.adddata.vat = (this.adddata.price - this.adddata.discount) * 7 /100
            this.adddata.afterdiscount = (this.adddata.price - this.adddata.discount)
            this.adddata.totalprice = (this.adddata.price - this.adddata.discount) +this.adddata.vat 
        },
        'adddata.discount'(){
            this.adddata.vat = (this.adddata.price - this.adddata.discount) * 7 /100
            this.adddata.afterdiscount = (this.adddata.price - this.adddata.discount)
            this.adddata.totalprice = (this.adddata.price - this.adddata.discount) +this.adddata.vat 
        },
        'addForm'(){
            this.adddata= {
                name: null,
                price: null,
                discount: null,
                vat: null,
                totalprice: null,
                status: 1,
                shop_id: 1,
                image: null
            }
        }
  },
    created() {
        this.getProduct();
        this.getShop();
    }
}
</script>
<style scoped>
.add-container {
    background: rgba(0, 0, 0, 0.1);
    width: 100%;
    height: 100%;
    position: fixed;
    top: 0;
    left: 0;
}

.addForm {
    background: white;
    width: 500px;
    height: auto;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    border-radius: 1em;
    border: solid 1px rgba(0, 0, 0, 0.3);
    display: flex;
    padding: 1em;
}

.addForm div {
    width: 100%;
}</style>